# DQ-Former: Querying Transformer with Dynamic Modality Priority for Cogntive-aligned Multimodal Emotion Recognition in Conversations

This repository contains the code for the paper "DQ-Former: Querying Transformer with Dynamic Modality Priority for Cogntive-aligned Multimodal Emotion Recognition in Conversations".

## Requirements

refer to envs/enviroment_abc.yml

## Data Preparation

You need to download the datasets and preprocess them before running the code. The data preprocessing steps are provided in the `preprocess` folder.

#### 1. Raw data download

The data is available at [IEMOCAP](https://sail.usc.edu/iemocap/), and [MELD](https://github.com/declare-lab/MELD.git).

#### 2. Data preprocessing

please refer to the `preprocess` folder for the data preprocessing steps.

## Run

You need to prepare the pre-trained models, and add the path to the `scripts/config/config.sh` file.

#### 1. Training

To train the model, you can run the following command:

```bash
bash scripts/run_train.sh
```
The settings for the training are provided in the `scripts/train/train.sh` file.

#### 2. Evaluation

To evaluate the model, you can run the following command:

```bash
bash scripts/run_eval.sh
```
The settings for the evaluation are provided in the `scripts/eval/eval.sh` file.


## Citation

If you find this code useful, please consider citing our paper:

```
@inproceedings{DQ-Former,
  title={DQ-Former: Querying Transformer with Dynamic Modality Priority for Cogntive-aligned Multimodal Emotion Recognition in Conversations},
  author={},
  booktitle={},
  year={2024}
}
```

## Contact

If you have any questions, please feel free to contact me via email

## Acknowledgement





