#region baseline
from .audio_only import AudioOnly
from .text_only import TextOnly
from .MBT import MBT
from .mult import Mult
#endregion

#region my_model
from .single_stream import Single_stream, Single_stream_mask_text, Single_stream_mask_audio
from .dq_wo_t import DQ_WO_T
from .dq_wo_amw import DQ_wo_AMW
from .dq_w_t import DQ_w_T, DQ_w_T_mask_audio, DQ_w_T_mask_text
from .dq_old import DQ_old, DQ_old_mask_audio, DQ_old_mask_text
#endregion


def load_model(args):
    model_mapping = {
        'audio_only': AudioOnly,
        'text_only': TextOnly,
        'mbt': MBT, 
        'mult': Mult,
        'single_stream': Single_stream,
        'single_stream_mask_text': Single_stream_mask_text,
        'single_stream_mask_audio': Single_stream_mask_audio,
        'dq_former': DQ_w_T,
        'dq_former_mask_text': DQ_w_T_mask_text,
        'dq_former_mask_audio': DQ_w_T_mask_audio,
    }
    assert args.model_name in model_mapping, f"Model {args.model_name} not found! \nModels supported: {model_mapping.keys()}"

    model = model_mapping.get(args.model_name, Single_stream)
    print(f">>> Using model {model.__name__}...")
    return model(args).to('cuda')
