#!/bin/bash

#region select gpus
num_gpus=$1  # Set the desired number of GPUs here

# wait for gpus
while true; do
    selected_gpus=$(python - <<END
import GPUtil

def get_free_gpus(num_gpus):
    try:
        available_gpus = GPUtil.getAvailable(order="memory", limit=num_gpus, maxLoad=0.1, maxMemory=0.1)
        if len(available_gpus) >= num_gpus:
            return available_gpus[:num_gpus]
        else:
            return None
    except Exception as e:
        print("Error while GPU selection:", str(e))
        return None

selected_gpus = get_free_gpus($num_gpus)  # Select the specified number of GPUs
if selected_gpus is not None:
    print(','.join(map(str, selected_gpus)))
else:
    print("Insufficient available GPUs.")
END
    )

    if [ ! -z "$selected_gpus" ] && [ "$selected_gpus" != "Insufficient available GPUs." ]; then
        export CUDA_VISIBLE_DEVICES=$selected_gpus
        echo "Setting GPU number to: $num_gpus"
        echo "Selected GPUs: $selected_gpus"
        break  # Break the loop if GPUs are available
    else
        echo "No available GPUs. Waiting for 1 minute..."
        sleep 60  # Wait for 1 minute before checking again
    fi
done

# export CUDA_VISIBLE_DEVICES='1'
#endregion

export WANDB_API_KEY="8e08a468fb27858ec32bfc43b816e80c5389f28c"

#region pretrain_model paths
# audio_encoders
whisper_small="/home/huggingface/pretrained_model/openai/whisper-small"
hubert_base_ls960="/home/huggingface/pretrained_model/facebook/hubert-base-ls960"
hubert_large_1160k="/home/huggingface/pretrained_model/facebook/hubert-large-ll60k"
wav2vec2_base="/home/huggingface/pretrained_model/facebook/wav2vec2-base"
wav2vec2_base_960h= "/home/huggingface/pretrained_model/facebook/wav2vec2-base-960h"
wav2vec2_large="/home/huggingface/pretrained_model/facebook/wav2vec2-large"
wavlm_base="/home/huggingface/pretrained_model/microsoft/wavlm-base"
wavlm_base_plus="/home/huggingface/pretrained_model/microsoft/wavlm-base-plus"
wavlm_large="/home/huggingface/pretrained_model/microsoft/wavlm-large"
# text_encoders
bert_large_uncased="/home/huggingface/pretrained_model/bert-large-uncased"
bert_base_uncased="/home/huggingface/pretrained_model/bert-base-uncased"
roberta_base="/home/huggingface/pretrained_model/roberta-base"
roberta_large="/home/huggingface/pretrained_model/roberta-large"
deberta_base="/home/huggingface/pretrained_model/microsoft/deberta-base"
deberta_large="/home/huggingface/pretrained_model/microsoft/deberta-v3-large"
llama2="/home/huggingface/pretrained_model/Llama-2-7b-hf"
llama2_chat="/home/huggingface/pretrained_model/Llama-2-7b-chat-hf"
# vision_encoders
vit_base_patch16_224="/home/huggingface/pretrained_model/google/vit-base-patch16-224"
#endregion

DATASET_ROOT_DIR="/home/datasets/ERC"