import os
import sys
import time
 
cmd = 'sh scripts/run_main.sh'
 
 
def gpu_info():
    gpu_status = os.popen('nvidia-smi | grep %').read().split('|')[1:]
    gpus_mem = []
    gpus_power = []
    for i in range(10):
        gpus_mem.append(int(gpu_status[i*4 + 1].split('/')[0].split('M')[0].strip()))
        gpus_power.append(int(gpu_status[i*4].split('   ')[-1].split('/')[0].split('W')[0].strip()))
    return gpus_power, gpus_mem


def get_available_gpus(gpus_power, gpus_memory):
    valid_ids = []
    for i, (p, mem) in enumerate(zip(gpus_power, gpus_memory)):
        if p < 20 and mem < 24000:
            valid_ids.append(i)
    return valid_ids
 
 
def narrow_setup(interval=2):
    i = 0
    while True:  # set waiting condition
        gpus_power, gpus_memory = gpu_info()
        valid_gpu = get_available_gpus(gpus_power, gpus_memory)
        if len(valid_gpu) >= 2:
            break
        i = i % 5
        symbol = 'monitoring: ' + '>' * i + ' ' * (10 - i - 1) + '|'
        gpu_power_str = 'Min gpu power:%d W |' % min(gpus_power)
        gpu_memory_str = 'Min gpu memory:%d MiB |' % min(gpus_memory)
        sys.stdout.write('\r' + gpu_memory_str + ' ' + gpu_power_str + ' ' + symbol)
        sys.stdout.flush()
        time.sleep(interval)
        i += 1
    print('\n' + cmd)
    cmd = cmd + f" {valid_gpu[0]} {valid_gpu[1]}"
    os.system(cmd)
 
 
if __name__ == '__main__':
    narrow_setup()